"use strict";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const {
  ActionTransport
} = require('@microfleet/core');

const Promise = require('bluebird');

const {
  ERROR_AUTH_REQUIRED
} = require('../../constants');

const attach = require('../../auth/oauth/utils/attach');

const {
  getSignedToken
} = require('../../auth/oauth/utils/get-signed-token');

async function facebookCallbackAction(request) {
  const {
    credentials
  } = request.auth;
  const {
    user,
    account
  } = credentials; // logged in, no account provided - bypass

  if (!account) {
    const {
      cookies
    } = this.config.jwt;

    if (cookies.enabled === true) {
      request.transportRequest.setState(cookies.name, credentials.jwt, cookies.settings);
    }

    return {
      payload: _objectSpread({}, credentials),
      error: false,
      type: 'ms-users:logged-in',
      title: 'signing in'
    };
  } // input data
  // TODO: customize what to encode


  const {
    uid,
    provider,
    email,
    profile,
    internals,
    missingPermissions
  } = account; // compose facebook context, would be encoded

  const facebook = {
    uid,
    email,
    provider,
    internals,
    profile: _objectSpread({}, profile)
  };
  const context = await Promise.bind(this, [facebook, user]).spread(user ? attach : getSignedToken);
  return {
    payload: context,
    error: false,
    missingPermissions,
    type: 'ms-users:attached',
    title: `Attached ${provider} account`
  };
}

async function isAllowed(request) {
  if (!request.auth.credentials) {
    throw ERROR_AUTH_REQUIRED;
  }
}

facebookCallbackAction.allowed = isAllowed;
facebookCallbackAction.auth = 'oauth';
facebookCallbackAction.strategy = 'facebook';
facebookCallbackAction.passAuthError = true;
facebookCallbackAction.transports = [ActionTransport.http];
module.exports = facebookCallbackAction;