"use strict";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Performs JWT token verification
 * @param  {string} token
 * @returns {Promise}
 */
exports.verifyToken = function verifyToken(token) {
  const {
    amqp,
    config
  } = this;
  const {
    prefix
  } = config.router.routes;
  const audience = config.jwt.defaultAudience;
  const payload = {
    token,
    audience
  };
  return amqp.publishAndWait(`${prefix}.verify`, payload);
};
/**
 * Attempts to sign in with a registered user
 * @param  {string} username
 * @returns {Promise}
 */


exports.loginAttempt = function loginAttempt(username, opts = {}) {
  const {
    amqp,
    config
  } = this;
  const {
    prefix
  } = config.router.routes;
  const audience = config.jwt.defaultAudience;

  const payload = _objectSpread({
    username,
    audience,
    isSSO: true
  }, opts);

  return amqp.publishAndWait(`${prefix}.login`, payload);
};